# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
import json

# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls


def update_package():
    result = False
    proxies = get_proxies()

    if not proxies:
        proxies = get_proxies_from_wapt_console()
    
    git_repo = "mitmproxy/mitmproxy"
    url_api = "https://api.github.com/repos/%s/releases/latest" % git_repo   
    # Getting latest version information from official sources
    print("API used is: %s" % url_api)
    json_load = json.loads(wgets(url_api, proxies=proxies))
    version = json_load["tag_name"].replace("v","")
    
    url_dl = f"https://downloads.mitmproxy.org/{version}/mitmproxy-{version}-windows-x86_64-installer.exe"
    filename = url_dl.split("/")[-1]

    if not isfile(filename):
        package_updated = True
        wget(url_dl,filename,proxies=proxies)

    #nettoyer les fichiers temporaires
    for f in glob.glob('*.exe'):
        if f != filename:
            remove_file(f)

    version =get_version_from_binary(filename)
    control.set_software_version(version)
    control.save_control_to_wapt()